Subject: bug#29696: Reading summary keys from article changes window configuration

From: "Basil L. Contovounesios" <[email-masked]>
Date: Wed, 13 Dec 2017 20:24:43 +0000

>From f615268be55ddfdfdc9c3c2f4f0a15ad6bafa183 Mon Sep 17 00:00:00 2001
From: "Basil L. Contovounesios" <[email-masked]>
Date: Wed, 13 Dec 2017 19:55:15 +0000
Subject: [PATCH] Do not pop to buffer for reading gnus summary keys

* lisp/gnus/gnus-art.el (gnus-article-read-summary-keys): Lookup
summary buffer keys from article buffer without affecting window
configuration.
---
 lisp/gnus/gnus-art.el | 9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

diff --git a/lisp/gnus/gnus-art.el b/lisp/gnus/gnus-art.el
index 6ee0d7b023..51e2a9a21f 100644
--- a/lisp/gnus/gnus-art.el
+++ b/lisp/gnus/gnus-art.el
@@ -6711,11 +6711,10 @@ gnus-article-read-summary-keys
 	  (member keys nosave-but-article)
 	  (member keys nosave-in-article))
       (let (func)
-	(save-window-excursion
-	  (pop-to-buffer gnus-article-current-summary)
-	  ;; We disable the pick minor mode commands.
-	  (let (gnus-pick-mode)
-	    (setq func (key-binding keys t))))
+        (with-current-buffer gnus-article-current-summary
+          ;; We disable the pick minor mode commands.
+          (let (gnus-pick-mode)
+            (setq func (key-binding keys t))))
 	(if (or (not func)
 		(numberp func))
 	    (ding)
-- 
2.15.1

Using Gnus with the user option pop-up-frames set to 'graphic-only, I
observe the following behaviour:

1. Visit an article.
2. Make article window the sole window in its containing frame.
3. Type = (gnus-summary-expand-window).

Expected result: The article's summary replaces the article in the
frame's sole window.

Actual result: The expected result plus an additional frame displaying
the corresponding summary buffer.  In other words, expanding the article
window causes an extraneous frame to be created.

I believe this is caused by a call to pop-to-buffer within
save-window-excursion in the function gnus-article-read-summary-keys.
Is the call to pop-to-buffer really necessary for the purpose of key
lookup?  Wouldn't changing the current buffer suffice, so as not to
affect the window configuration in the first place?

If so, please consider the attached patch which addresses this.  The
docstring of save-window-excursion even warns of the possibility of
behaviour like the one I describe.

The information gathered by gnus-bug follows my signature.

Thanks,

-- 
Basil

Gnus v5.13
GNU Emacs 27.0.50 (build 9, x86_64-pc-linux-gnu, X toolkit, Xaw3d scroll bars)
 of 2017-12-05